<?php
error_reporting(0);

class ControllerExtensionPaymentshopinextPayment extends Controller
{

    private $valid_currency = array("TRY", "USD", "EUR");

    public function index()
    {
        $this->load->language('extension/payment/shopinext_payment');
        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $cart_total_amount = round($order_info['total'] * $order_info['currency_value'], 2);
        $data['cart_total'] = $cart_total_amount;
        $data['code'] = $this->language->get('code');
        $data['text_credit_card'] = $this->language->get('text_credit_card');
        $data['text_wait'] = $this->language->get('text_wait');
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['kart_name'] = $this->language->get('kart_name');
        $data['kart_numara'] = $this->language->get('kart_numara');
        $data['kart_ay'] = $this->language->get('kart_ay');
        $data['kart_yil'] = $this->language->get('kart_yil');
        $data['odemeyap'] = $this->language->get('odemeyap');
        $data['continue'] = $this->url->link('checkout/success');
        $data['error_page'] = $this->url->link('checkout/error');
        $data['form_class'] = $this->config->get('payment_shopinext_payment_form_type');
        $data['form_type'] = $this->config->get('payment_shopinext_payment_checkout_type');
        if (VERSION >= '2.2.0.0') {
            $template_url = 'extension/payment/shopinext_payment';
        } else {
            $template_url = 'default/template/extension/payment/shopinext_payment';
        }
        return $this->load->view($template_url, $data);

    }

    public function checkoutform()
    {
        try {
            $data['checkout_form_content'] = '';
            $data['error'] = '';
            $data['form_class'] = $this->config->get('payment_shopinext_payment_form_type');
            $data['form_type'] = $this->config->get('payment_shopinext_payment_checkout_type');
            $data['continue'] = $this->url->link('checkout/success');
            $data['error_page'] = $this->url->link('checkout/error');
            $data['display_direct_confirm'] = 'no';
            $route_url = 'extension/payment/shopinext_payment/callback';
            $callback_url = $this->getSiteUrl() . 'index.php?route=' . $route_url;
            $order_id = $this->session->data['order_id'];
            $unique_conversation_id = (string) $order_id;
            $this->load->language('extension/payment/shopinext_payment');
            if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/payment/shopinext_payment')) {
                $this->template = $this->config->get('config_template') . '/template/extension/payment/shopinext_payment';
            } else {
                $this->template = 'default/template/extension/payment/shopinext_payment';
            }
            $this->load->model('checkout/order');
            $this->load->model('checkout/order');
            $this->load->model('setting/setting');

            $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
            if (!in_array($order_info['currency_code'], $this->valid_currency)) {
                throw new \Exception($this->language->get('error_invalid_currency'));
            }
            $cart_total_amount = round($order_info['total'] * $order_info['currency_value'], 2);
            if ($cart_total_amount == 0) {
                $data['display_direct_confirm'] = 'yes';
                $this->response->addHeader('Content-Type: application/json');
                $this->response->setOutput(json_encode($data));
                return true;
            }
            $locale = 'en';
            $siteLang = explode('-', $order_info['language_code']);
            if ($siteLang[0] == 'tr') {
                $locale = 'tr';
            }
            $order_info_firstname = !empty($order_info['firstname']) ? $order_info['firstname'] : "NOT PROVIDED";
            $order_info_lastname = !empty($order_info['lastname']) ? $order_info['lastname'] : "NOT PROVIDED";
            $order_info_telephone = !empty($order_info['telephone']) ? $order_info['telephone'] : "NOT PROVIDED";
            $order_info_email = !empty($order_info['email']) ? $order_info['email'] : "NOT PROVIDED";
            $order_info_ip = !empty($order_info['ip']) ? $order_info['ip'] : "NOT PROVIDED";
            $address = !empty($order_info['address_1']) ? $order_info['address_1'] : "NOT PROVIDED";
            if (function_exists('curl_version')) {
                $snid = $this->config->get('payment_shopinext_payment_snid');
                $api = $this->config->get('payment_shopinext_payment_api');
                $sifre = $this->config->get('payment_shopinext_payment_sifre');
				if($this->getCurrencyConstant($order_info['currency_code']) !== 'TRY') {
					$data = array(
						'ACTION'=>'CURRENCY',
						'SNID' => $snid,
						'APIKEY' => $api,
						'SNPASS' => $sifre,
						'CURRENCY'=>$this->getCurrencyConstant($order_info['currency_code'])
					);
					$ch=curl_init();
					curl_setopt($ch, CURLOPT_URL, "https://www.shopinext.com/api/v1");
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($ch, CURLOPT_POST, 1) ;
					curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
					curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
					curl_setopt($ch, CURLOPT_TIMEOUT, 20);
					$result = json_decode(curl_exec($ch));
					if(curl_errno($ch))
						die("Bağlantı hatası. err:".curl_error($ch));
					curl_close($ch);    
					if(isset($result->amount)) {
						$cart_total_amount = $cart_total_amount * $result->amount;
					}
				}
                $shopinextArray = array(
					'ACTION' => 'SESSIONTOKEN',
					'SNID' => $snid,
					'APIKEY' => $api,
					'SNPASS' => $sifre,
                    'RETURNURL' => $callback_url,
                    'PRICE' => $cart_total_amount,
                    'CUSTOMERIP' => $order_info_ip,
                    'CUSTOMERNAME' => $order_info_firstname . ' ' . $order_info_lastname,
                    'CUSTOMERPHONE' => $order_info_telephone,
                    'CUSTOMEREMAIL' => $order_info_email,
                    'BILLTOADDRESSLINE' => $address.' '.$order_info['payment_address_2'],
                    'BILLTOCITY' => $order_info['payment_city'],
                    'BILLTOCOUNTRY' => $order_info['payment_iso_code_3'],
                    'BILLTOPOSTALCODE' => $order_info['payment_postcode'],
                    'BILLTOPHONE' => $order_info_telephone,
                    'SHIPTOADDRESSLINE' => $address.' '.$order_info['payment_address_2'],
                    'SHIPTOCITY' => $order_info['payment_city'],
                    'SHIPTOCOUNTRY' => $order_info['payment_iso_code_3'],
                    'SHIPTOPOSTALCODE' => $order_info['payment_postcode'],
                    'SHIPTOPHONE' => $order_info_telephone,
					'CUSTOMERUSERAGENT'=>$_SERVER['HTTP_USER_AGENT'],
                );
				 $ch=curl_init();
				curl_setopt($ch, CURLOPT_URL, "https://www.shopinext.com/api/v1");
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_POST, 1) ;
				curl_setopt($ch, CURLOPT_POSTFIELDS, $shopinextArray);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
				curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
				curl_setopt($ch, CURLOPT_TIMEOUT, 20);
				$result = json_decode(curl_exec($ch));
				if(curl_errno($ch))
					die("Bağlantı hatası. err:".curl_error($ch));
				curl_close($ch);    
				if(isset($result->sessionToken)) {
					$this->session->data['payment_session'] = $result->sessionToken;
				} else {
					$this->response->addHeader('Content-Type: application/json');
					$this->response->setOutput(json_encode($result = array('status' => $result->errorCode, 'message' => $result->errorMsg)));
				}
            } else {
                $data['error'] = $this->language->get("Error_message_curl");
                $this->response->addHeader('Content-Type: application/json');
                $this->response->setOutput(json_encode($result = array('status' => 'failure', 'message' => 'Curl Connected Failure')));
            }
        } catch (\Exception $exc) {
            $return = $exc->getMessage();
            $this->response->addHeader('Content-Type: application/json');
            $this->response->setOutput(json_encode($result));
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($result, true));
    }
	
    public function callback()
    {
        $server_conn_slug = $this->getServerConnectionSlug();
        $this->load->language('extension/payment/shopinext_payment');
        $this->load->model('extension/payment/shopinext_payment');
        $this->load->model('checkout/order');
        $postData = $this->request->post;
        try {
            if (empty($postData['responseCode'])) {
                throw new \Exception($this->language->get('invalid_request'));
            }
            $order_id = $this->session->data['order_id'];
            if ($postData['responseCode'] == 99) {
                throw new \Exception($postData['responseMsg']);
            } else if(isset($postData['responseCode']) && $postData['responseCode'] == 00) {
				if($this->session->data['payment_session'] == $postData['sessionToken']) {
					unset($this->session->data['payment_session']);
					$data = array(
						'ACTION'=>'ISDONE',
						'SESID'=>$postData['sessionToken']
					);  
					$ch=curl_init();
					curl_setopt($ch, CURLOPT_URL, "https://www.shopinext.com/api/v1");
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt($ch, CURLOPT_POST, 1) ;
					curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
					curl_setopt($ch, CURLOPT_FRESH_CONNECT, true);
					curl_setopt($ch, CURLOPT_TIMEOUT, 20);
					$result = json_decode(curl_exec($ch));
					if(curl_errno($ch))
						die("Bağlantı hatası. err:".curl_error($ch));
					curl_close($ch);
					if($result->responseCode == 00) {
						$message .= 'Payment ID: ' . $order_id . "\n";
						$order_info = $this->model_checkout_order->getOrder($order_id);
						$this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_shopinext_payment_order_status_id'), $message, false);
						$this->response->redirect($this->url->link('checkout/success', '', $server_conn_slug));
					} else {
						throw new \Exception($postData['responseMsg']);
					}
				} else {
					throw new \Exception('Invalid Token');
				}
            } else {
				throw new \Exception($postData['responseMsg']);
			}
        } catch (\Exception $ex) {
            $resp_msg = $ex->getMessage();
            $resp_msg = !empty($resp_msg) ? $resp_msg : $this->language->get('invalid_request');
            $this->session->data['error'] = $resp_msg;
            $this->response->redirect($this->url->link('checkout/checkout', '', $server_conn_slug));
        }
    }

    public function getSiteUrl()
    {
        if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) {
            $site_url = is_null($this->config->get('config_ssl')) ? HTTPS_SERVER : $this->config->get('config_ssl');
        } else {
            $site_url = is_null($this->config->get('config_url')) ? HTTP_SERVER : $this->config->get('config_url');
        }
        return $site_url;
    }

    public function getServerConnectionSlug()
    {
        if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) {
            $connection = 'SSL';
        } else {
            $connection = 'NONSSL';
        }
        return $connection;
    }

    private function _getCurrencySymbol($currencyCode)
    {
        $currencySymbol = $this->currency->getSymbolLeft($currencyCode);
        if ($currencySymbol == '') {
            $currencySymbol = $this->currency->getSymbolRight($currencyCode);
        } else if ($currencySymbol == '') {
            $currencySymbol = $currencyCode;
        }
        return $currencySymbol;
    }

    public function replaceSpace($veri)
    {
        $veri = str_replace("/s+/", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace("/s/g", "", $veri);
        $veri = str_replace("/s+/g", "", $veri);
        $veri = trim($veri);
        return $veri;
    }

    private function getCurrencyConstant($currencyCode)
    {
        $currency = 'TRY';
        switch ($currencyCode) {
            case "TRY":
                $currency = 'TRY';
                break;
            case "USD":
                $currency = 'USD';
                break;
            case "EUR":
                $currency = 'EUR';
                break;
        }
        return $currency;
    }

}
